Point averagePoint (ArrayList<Point> array, float concentration) {
  int theSize = array.size();
  float theSum = 0;
  float totalPoints = 0;
  float theZ = array.get(0).getZ();
  for (int i = 0; i < theSize; i++) {
    Point currentPoint = array.get(i);
    float currentX = currentPoint.getX();
    
    if (currentX == concentration) {
      theSum = theSum + currentPoint.getY();
      totalPoints = totalPoints + 1;
    }
  }
  if (theSum > 0) {
    float average = theSum / totalPoints;
    Point newPoint = new Point (concentration, average, theZ);
    return newPoint;
  }
  else {
    return null;
  }
}

ArrayList<Point> averageLine (ArrayList<Point> array) {
  ArrayList<Point> averagePoints = new ArrayList<Point>();
  int theSize = array.size();
  if (theSize > 0) {
    for (int i = 0; i < numConcentrations; i++) {
      float concentration = map (i, 0, 10, minX, maxX);
      Point newPoint = averagePoint (array, concentration);
      
      if (newPoint != null) {
        averagePoints.add(newPoint);
      }
    }
  }
  return averagePoints; 
}

ArrayList<Point> firstLast (ArrayList<Point> array) {
  ArrayList<Point> averagePoints = new ArrayList<Point>();
  int theSize = array.size();
  if (theSize > 1) {
      Point firstPoint = array.get(0);
      float firstConc = firstPoint.getX();
      
      Point firstAverage = averagePoint(array, firstConc);
      averagePoints.add(firstAverage);
      
      Point lastPoint = array.get(theSize-1);
      float lastConc = lastPoint.getX();
      Point lastAverage = averagePoint(array,lastConc);
      averagePoints.add(lastAverage);
  }
  return averagePoints;
}
