boolean highlightAntibiotics = false;
boolean highlightPhages = false;
boolean showAverage = false;
boolean showEffective = false;
boolean differStrain = false;

color [] colors = {#613547,#623B51,#60415B,#5E4865,#59506D,#525775,#4A5F7B,#406680,#356D82,#2A7483,#207B82,
#1A827F,#1D887B,#288D75,#36936E,#469766,#579C5E,#699F56,#7CA24E,#8FA548,#A2A643,#B6A741,#CAA743,#DDA648};

color[] antPhageColors = {#324C60, #6CB66B};


void effectiveColor (ArrayList<Point> array) {
  int arraySize = array.size();
  Point firstPoint = array.get(0);
  float firstConcentration = firstPoint.getX();
  
  Point averageFirstPoint = averagePoint(array, firstConcentration);
  float startingY = averageFirstPoint.getY();
  
  
  for (int i = 0; i < arraySize; i++) {
    Point currentPoint = array.get(i);
    float currentY = currentPoint.getY();

    float difference = startingY - currentY;
    float mappedDifference = map(difference, minY, maxY, -1, 1);
    
    if (mappedDifference > 0.8) {
      currentPoint.setColor(#8E5640);
    }
    else if (mappedDifference > 0.6) {
      currentPoint.setColor(#9A6441);
    }
    else if (mappedDifference > 0.4) {
      currentPoint.setColor(#A37442);
    }
    else if (mappedDifference > 0.2) {
      currentPoint.setColor(#A98545);
    }
    else if (mappedDifference > -0.2) {
      currentPoint.setColor(#AC974B);
    }
    else if (mappedDifference > -0.4) {
      currentPoint.setColor(#ACA956);
    }
    else if (mappedDifference > -0.6) {
      currentPoint.setColor(#A9BC65);
    }
    else if (mappedDifference > -0.8) {
      currentPoint.setColor(#A4CE79);
    }
    else {
      currentPoint.setColor(#9DE092);
    }
  }
  
  
  
  
}
