class Point {
  float x, y, z;
  color c = 255;
  int pointStroke = 2;
  
  Point (float theX, float theY, float theZ) {
    this.x = theX;
    this.y = theY;
    this.z = theZ;}
    
  float getX () { return x;}
  float getY() {return y;}
  float getZ() {return z;}
  
  void setColor (color theColor) {
    this.c = theColor;
  }
  color getColor () {
    return this.c;
  }
  
  void setTheStroke (int theStroke) {
    this.pointStroke = theStroke;
  }
  int getTheStroke () {
    return this.pointStroke;
  }
}

static class AscendingOrder implements Comparator<Point> {
    public int compare (Point a, Point b) {
    float aX = a.getX();
    float bX = b.getX();
    
    float diff = aX - bX;
    
    if (diff == 0) {
      float aY = a.getY();
      float bY = b.getY();
      float yDiff = aY - bY;
      
      if (yDiff < 0) {return 1;}
      else if (yDiff > 0) { return -1;}
      else {return 0;}
    }
    
    else if (diff < 0) {return -1;}
    else {return 1;} 
  }
}

public static <AnyType> void sort (ArrayList<AnyType> arr, Comparator <? super AnyType> cmp) {
    for (int i = 0; i < arr.size() - 1; i++) {
        int index = i;

        for (int j = i+1; j < arr.size(); j++) {
            if (cmp.compare(arr.get(j), arr.get(index)) < 0) {
                index = j;
            }
        }
        AnyType temp = arr.get(index);
        arr.set(index, arr.get(i));
        arr.set(i, temp);
    }
}
