boolean showLines = false;
boolean showFill = false;

boolean [] treatmentBoolValues = new boolean [24];

int DisplayNum = 1;

void initializeArray () {
  Arrays.fill(treatmentBoolValues, true);
}

void gui() {
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  cp5.draw();
  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);
}

void dropdown(int n) { DisplayNum = n + 1; }

void disableCam () {
  if (cp5.isMouseOver()) { cam.setActive(false); }
  else { cam.setActive(true);}}
  

ScrollableList makeScrollList () {
  return cp5.addScrollableList("dropdown")
    .setPosition(10, 10)
    .setSize(100, 100)
    .setBarHeight(20)
    .setItemHeight(20)
    .addItems(strains)
    .setId(1)
    .setOpen(true);
}

Toggle makeToggle (String name, int position1, int position2) {
  return cp5.addToggle(name)
     .setPosition(position1, position2)
     .setSize(40,15);
}

RadioButton makeRadio () {
  return cp5.addRadioButton("radioButton")
         .setPosition(0,50)
         .setSize(40,15)
         .setColorForeground(color(120))
         .setColorActive(color(255))
         .setColorLabel(color(255))
         .setItemsPerRow(2)
         .setSpacingColumn(50)
         .addItem("Antibiotic",1)
         .addItem("Phage",2)
         .addItem("Strain",3)
         .addItem("Effective",4);
}

CheckBox makeCheckbox () {
  return cp5.addCheckBox("treatmentCheckbox")
    .setPosition(0,10)
    .setSize(10,10)
    .setItemsPerRow(6)
    .setSpacingColumn(25)
    .setSpacingRow(20)
    .addItem("AMX", 1)
    .addItem("BW-1", 2)
    .addItem("CEF", 3)
    .addItem("CHL", 4)
    .addItem("CIP", 5)
    .addItem("ERY", 6)
    .addItem("GEN", 7)
    .addItem("HK", 8)
    .addItem("Lam", 9)
    .addItem("M13", 10)
    .addItem("N4", 11)
    .addItem("O8", 12)
    .addItem("PlB", 13)
    .addItem("PRD1", 14)
    .addItem("QB", 15)
    .addItem("RB69", 16)
    .addItem("RIF", 17)
    .addItem("T4", 18)
    .addItem("T5", 19)
    .addItem("T6", 20)
    .addItem("T7", 21)
    .addItem("TIG", 22)
    .addItem("TRM", 23)
    .addItem("U3", 24)
    .activateAll();
    
}

void treatmentCheckbox (float [] a) {
  int numItems = a.length;
  treatmentBoolValues = new boolean [numItems];
  for (int i = 0; i < numItems; i++) {
    if (a[i] == 1) { treatmentBoolValues[i] = true; }
    else { treatmentBoolValues[i] = false; }
  }}

void radioButton (int a) {
  if (a == 1) {
    highlightAntibiotics = true;
    highlightPhages = false;
    differStrain = false;
    showEffective = false;
  }
  if (a == 2) {
    highlightAntibiotics = false;
    highlightPhages = true;
    differStrain = false;
    showEffective = false;
  }
  if (a == 3) {
    highlightAntibiotics = false;
    highlightPhages = false;
    differStrain = true;
    showEffective = false;
  }
  if (a == 4) {
    highlightAntibiotics = false;
    highlightPhages = false;
    differStrain = false;
    showEffective = true;
  }
  if (a == -1) {
    highlightAntibiotics = false;
    highlightPhages = false;
    differStrain = false;
    showEffective = false;
  }
}

void lines (boolean on) {
  if (on == true) {showLines = true;}
  else {showLines = false;}}

void fill (boolean on) {
  if (on == true) { showFill = true;}
  else {showFill = false;} }
  
void average (boolean on) {
  if (on == true) { showAverage = true;}
  else { showAverage = false;}}
  
void accordionGUI() {
  cp5 = new ControlP5(this);
  Group g1 = cp5.addGroup("Toggle Lines and Color")
   .setBackgroundColor(color(0, 64))
   .setBackgroundHeight(10);
    
  makeToggle("lines", 0, 10).moveTo(g1);
  makeToggle("fill", 50, 10).moveTo(g1);
  makeToggle("average", 100,10).moveTo(g1);
  makeRadio().moveTo(g1);
  
  Group g2 = cp5.addGroup("Select Treatment")
    .setBackgroundColor(color(0,64))
    .setBackgroundHeight(150);
   
  makeCheckbox().moveTo(g2);
  
  Group g3 = cp5.addGroup("Select Strain")
    .setBackgroundColor(color(0,64))
    .setBackgroundHeight(150);
   
  makeScrollList().moveTo(g3);
  
  accordion =  cp5.addAccordion("acc")
    .setPosition(40,40)
    .setWidth(200)
    .addItem(g1)
    .addItem(g2)
    .addItem(g3);
    
}
