void TreatmentMapping(int num, String name) {
  int maxValue = 24;
  smooth();
  pushMatrix();
  float word = map(num, 0, maxValue, minZ, maxZ);
  fill (100);
  translate (minX, -minY, word);
  textAlign (RIGHT, CENTER);
  scale(0.25);
  rotateX(HALF_PI);
  text (name, 0, 0);
  popMatrix();
}

void ConcentrationMapping (int num, float conc) {
  int maxValue = numConcentrations - 1;
  smooth();
  pushMatrix();
  float word = map(num, 0, maxValue, minX, maxX);
  fill(100);
  translate (word, -minY, maxZ);
  textAlign (CENTER, TOP);
  scale(0.25);
  text (nf(conc,0,1), 0, 0);
  popMatrix();
}

void ConcentrationValues () {
  for (int i = 0; i < numConcentrations; i++) {
    ConcentrationMapping(i, concentrations[i]);
  }}
  
void TreatmentNames() {
  for (int i = 0; i < numTreatments; i++) {
    TreatmentMapping(i, treatmentNames[i]);
  }}
